function [ features ] = CalculateFeature(curr_imagedir,param)

I = imread(curr_imagedir);
[height,width,~] = size(I);
if max(height,width) > param.maxImageSize    
    I = imresize(I, param.maxImageSize/max(height,width), 'bicubic'); 
end
features.imageHeight = size(I,1);
features.imageWidth = size(I,2);
if strcmp(param.sift.mutliScale_type,'ImageScale') == 1
    sift = getDenseSIFT(I,'step', param.sift.step, 'scales', param.sift.scales);
    features.fea = sift.descr'; 
    features.x = sift.frame(1,:)';
    features.y = sift.frame(2,:)';
    features.mask = (sift.contrast > param.sift.contrast)';
else
    [RawFeas RawPos] = GenerateRawFea(I,param.sift);
    features.fea = RawFeas';
    features.x = RawPos(1,:)';
    features.y = RawPos(2,:)';
    features.mask = (RawPos(3,:) > param.sift.contrast)';       
end


features.fea = bsxfun(@minus, features.fea, param.pca.PCA_mean);
if param.pca.whiteningflag == 1
    features.fea = features.fea * param.pca.PCA_U_whiten ;
else
    features.fea = features.fea * param.pca.PCA_U ;
end


    
