function [fimage] = buildfeaturesGabor(inimage)
% buildfeatures generates raw feature for L2ECM image feature.
%
% Please cite the following paper if you use the code:
%
%Peihua Li,  Qilong Wang: Local Log-Euclidean Covariance Matrix (L2ECM) for Image 
%Representation and Its Applications, (ECCV) 2012.
% For questions,  please conact:  Qilong Wang  (Email:  wangqilong.415@163.com), 
%                                               Peihua  Li (Email: peihuali at dlut dot edu dot cn) 
%
% The software is provided ''as is'' and without warranty of any kind,
% experess, implied or otherwise, including without limitation, any
% warranty of merchantability or fitness for a particular purpose.

[height width depth] = size(inimage);

fdim = 24;
fimage = zeros(height, width, fdim);

gimage = im2double(rgb2gray(inimage));

filter=fspecial('gaussian', 3, 0.5); % gaussian filter
gimage = conv2(gimage, filter, 'same'); 

%%%%%%%%%%% Gabor features
Gabor_options.Width=17;
Gabor_options.num_theta=8;
Gabor_options.num_scale=3;
[GR,GI]=Create_GaborFilters (Gabor_options);
Gabor_F = Apply_Gabor_Transform(gimage,1,GR, GI);
fimage(:,:,1:24)   = Gabor_F;

%fimage = bsxfun(@rdivide, fimage, sqrt(sum(sum((fimage .^2)))));


end

