function imdb = setupdataset(image_dataset,iter)

opts.dataset = image_dataset;
opts.datasetDir = ['images\'  image_dataset];
opts.seed = 0;
opts.lite = false;
switch opts.dataset
   case 'scene67', imdb = setupScene67(opts.datasetDir, 'lite', opts.lite) ;
   case 'sun397', imdb = setupSUN397(opts.datasetDir, iter, 'lite', opts.lite) ;
   case 'caltech101', imdb = setupCaltech256(opts.datasetDir, 'lite', opts.lite, ...
                                             'variant', 'caltech101', 'seed', opts.seed) ;
   case 'caltech256', imdb = setupCaltech256(opts.datasetDir, 'lite', opts.lite) ;
   case 'voc07', imdb = setupVoc(opts.datasetDir, 'lite', opts.lite, 'edition', '2007') ;
   case 'fmd', imdb = setupFMD(opts.datasetDir, 'lite', opts.lite) ;
   case 'scene15', imdb = setupScene15(opts.datasetDir, 'lite', opts.lite,'seed', opts.seed) ;
   case 'uiuc_sports', imdb = setupUiuc_Sports(opts.datasetDir, 'lite', opts.lite,'seed', opts.seed) ;
   otherwise, error('Unknown dataset type.') ;
end
